/* This routine builds on the strtok.c program. However, this program
   does NOT use I/O redirection for input. Rather it reads the command
   line for the name of a file to parse. The number of delimiters in
   tkn has been increased. A line and word counter have been added.

   The output of the cparse.exe program may be piped through the DOS SORT
   filter program and then piped through the NDXR.EXE file (written in
   Turbo Pascal 5.0 (source not included)) and then redirected to another
   file. NDXR is just a simple control-break program. 
*/

#include <stdio.h>
#include <string.h>
#include <conio.h>

main(int argc, char *argv[])
{
	FILE 	*fileptr; /* set up a pointer to a file*/
	char 	str[128];
	
	int line, wrd;
 
	char 	*tkn = "\t\n(){},;\" \\*/<>=:|."; 
					/* look for these delimiters in a */
					/* string: tab,newline,parens,    */
					/* braces,semicolons,double quotes*/
					/* spaces,backslashes,asterisks   */
					/* foreslashes, greater/less thans*/
					/* equals,colons,periods.	  */ 
	char 	*ptr = str;
	

	if (argc != 2)			/* check for proper usage         */
		{
			printf("USAGE: cparse  filename ");exit();
		}

	if( ( fileptr= fopen ( argv[1] ,"r" )) == NULL)
		{
		printf("Unable to open file %s.", argv[1]); exit();
		}

	clrscr();
					/* start reading a text file     */
					/* a line at a time		 */

	line = wrd = 1;			/* initialize line,word cntrs    */

	while  ( fgets ( str, 80, fileptr) != NULL)
	{
		ptr = strtok (str, tkn);/* call strtok() the first time  */

		if (ptr) printf ("%s ;%2d %2d\n",strlwr(ptr),line,wrd++);
			                /* print the word, if available  */
					/* in lower case, with line and  */
					/* word counter			 */

		do
		{			/* make the first argument into  */
		ptr = strtok( NULL, tkn);/* a NULL char and keep doing    */
		if (ptr)		/* this while it's OK.		 */
		printf ("%s ;%2d %2d\n",strlwr(ptr),line,wrd++);		
		} while ( ptr );
	line++;				/* increment the line counter    */
	wrd=1;				/* reset the word counter	 */
	}				/* or you run out of text from   */
	fclose ( fileptr );		/* the file.			 */
}

					/* And that's all he wrote....   */

/* Now try :	cparse  cparse.c | sort | > cparse.srt

	or :	cparse  cparse.c | sort | ndxr > cparse.ndx

   You've got most of the makings of a quick and dirty cross-referencer.
*/
		